"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var _typeof = _interopDefault(require("@babel/runtime/helpers/typeof")), _objectWithoutProperties = _interopDefault(require("@babel/runtime/helpers/objectWithoutProperties")), _objectSpread = _interopDefault(require("@babel/runtime/helpers/objectSpread")), nodePath = _interopDefault(require("path")), createBabelFile = _interopDefault(require("babel-file")), babelFileLoader = require("babel-file-loader"), babelFlowIdentifiers = require("babel-flow-identifiers"), babelTypeScopes = require("babel-type-scopes"), babelIdentifiers = require("babel-identifiers"), babelReactComponents = require("babel-react-components"), createBabylonOptions = _interopDefault(require("babylon-options")), t = require("@babel/types"), babelNormalizeComments = require("babel-normalize-comments"), resolve = require("resolve"), babelExplodeModule = require("@aparna036/babel-explode-module"), babelHelperSimplifyModule = require("babel-helper-simplify-module"), printAST = _interopDefault(require("ast-pretty-print"));

function matchExported(file, exportName) {
  var exploded = babelExplodeModule.explodeModule(file.path.node), statements = babelHelperSimplifyModule.explodedToStatements(exploded), program = Object.assign({}, file.path.node, {
    body: statements
  });
  file.path.replaceWith(program);
  var match = exploded.exports.find(function(item) {
    return item.external === exportName;
  });
  if (!match) return null;
  var local = match.local;
  return local ? ("default" === local && match.source && (local = exportName), file.path.get("body").find(function(item) {
    if (!item.isDeclaration() || item.isExportAllDeclaration()) return !1;
    var id = null;
    if (item.isVariableDeclaration()) id = item.node.declarations[0].id; else if (item.isImportDeclaration()) id = item.node.specifiers[0].local; else if (item.isExportNamedDeclaration()) id = item.node.specifiers[0].exported; else {
      if (!item.node.id) throw new Error("Unexpected node:\n\n".concat(printAST(item)));
      id = item.node.id;
    }
    if (!id) throw new Error("Couldn't find id on node:\n\n".concat(printAST(item)));
    return id.name === local;
  }) || null) : null;
}

var converters = {}, isSpecialReactComponentType = function(path, type) {
  if (path && path.isCallExpression()) {
    var callee = path.get("callee");
    if (callee.isIdentifier() && callee.node.name === type) return !0;
    if (callee.isMemberExpression() && callee.matchesPattern("React.".concat(type))) return !0;
  }
  return !1;
}, getPropFromObject = function getPropFromObject(props, property) {
  var prop;
  if (!props.members) throw new Error("Attempted to get property from non-object kind: ".concat(props.kind, ". Full object: ").concat(JSON.stringify(props)));
  return props.members.forEach(function(p) {
    if ("spread" === p.kind) {
      var spreadArg = resolveFromGeneric(p.value);
      if (!spreadArg || "object" !== spreadArg.kind) return;
      var p2 = getPropFromObject(spreadArg, property);
      p2 && (prop = p2);
    } else "id" === property.key.kind && p.key.name === property.key.name ? prop = p : "string" === property.key.kind && p.key.value === property.key.value && (prop = p);
  }), prop;
}, resolveFromGeneric = function resolveFromGeneric(type) {
  return "generic" !== type.kind ? type : resolveFromGeneric(type.value);
}, getProp = function getProp(props, property) {
  var prop;
  return "intersection" === props.kind ? props.types.forEach(function(pr) {
    prop = getProp(resolveFromGeneric(pr), property) || prop;
  }) : "object" === props.kind && (prop = getPropFromObject(props, property)), prop;
}, isVariableOfMembers = function(defaultProps) {
  if (!(defaultProps && defaultProps.value && "variable" === defaultProps.value.kind)) return !1;
  var declarations = defaultProps.value.declarations;
  return !!("object" === declarations[declarations.length - 1].value.kind);
}, getDefaultProps = function(path, context) {
  var defaultProps = null, foundDefaults = path.get("body").get("body").find(function(p) {
    return p.isClassProperty() && p.get("key").isIdentifier({
      name: "defaultProps"
    });
  });
  if (foundDefaults && (defaultProps = convert(foundDefaults, _objectSpread({}, context, {
    mode: "value"
  }))), defaultProps) {
    if (defaultProps && defaultProps.value && "object" === defaultProps.value.kind) return defaultProps.value.members;
    if (isVariableOfMembers(defaultProps)) return defaultProps.value.declarations[defaultProps.value.declarations.length - 1].value.members;
    throw new Error("Could not resolve default Props, ".concat(defaultProps));
  }
  return [];
};

function convertReactComponentFunction(path, context) {
  var functionProperties = convert(path.get("params.0.typeAnnotation"), _objectSpread({}, context, {
    mode: "type"
  })), name = "";
  if ("FunctionDeclaration" === path.type && path.node.id && path.node.id.name) name = path.node.id.name; else {
    var variableDeclarator = path.findParent(function(scopedPath) {
      return scopedPath.isVariableDeclarator();
    });
    variableDeclarator && (name = variableDeclarator.node.id.name);
  }
  var defaultProps = [];
  return name && (path.hub.file.path.traverse({
    AssignmentExpression: function(assignmentPath) {
      var left = assignmentPath.get("left.object");
      if (left.isIdentifier() && left.node.name === name) {
        var initialConversion = convert(assignmentPath.get("right"), _objectSpread({}, context, {
          mode: "value"
        }));
        defaultProps = initialConversion.members;
      }
    }
  }), functionProperties.name = {
    kind: "id",
    name: name,
    type: null
  }), addDefaultProps(functionProperties, defaultProps);
}

function addDefaultProps(props, defaultProps) {
  return defaultProps ? (defaultProps.forEach(function(property) {
    var ungeneric = resolveFromGeneric(props), prop = getProp(ungeneric, property);
    prop ? prop.default = property.value : console.warn("Could not find property to go with default of ".concat(property.key.value ? property.key.value : property.key.name, " in ").concat(props.name, " prop types"));
  }), props) : props;
}

function convertReactComponentClass(path, context) {
  var props = path.get("superTypeParameters").get("params")[0], defaultProps = getDefaultProps(path, context), classProperties = convert(props, _objectSpread({}, context, {
    mode: "type"
  }));
  return classProperties.name = convert(path.get("id"), _objectSpread({}, context, {
    mode: "value"
  })), classProperties.value && classProperties.value.members && (classProperties.value.members = classProperties.value.members.filter(function(m) {
    return !!m;
  })), addDefaultProps(classProperties, defaultProps);
}

function convertCall(path, context) {
  return {
    callee: convert(path.get("callee"), context),
    args: path.get("arguments").map(function(a) {
      return convert(a, context);
    })
  };
}

function isTsIdentifier(path) {
  return -1 !== [ "TSExpressionWithTypeArguments", "TSTypeReference" ].indexOf(path.parentPath.type) && "reference" === babelIdentifiers.getIdentifierKind(path);
}

function convertParameter(param, context) {
  var _convert = convert(param, context), type = _convert.type;
  return {
    kind: "param",
    value: _objectWithoutProperties(_convert, [ "type" ]),
    type: type || null
  };
}

function convertFunction(path, context) {
  var parameters = path.get("params").map(function(p) {
    return convertParameter(p, context);
  }), returnType = null, id = null;
  return path.node.returnType && (returnType = convert(path.get("returnType"), context)), 
  path.node.id && (id = convert(path.get("id"), context)), {
    kind: "function",
    id: id,
    async: path.node.async,
    generator: path.node.generator,
    parameters: parameters,
    returnType: returnType
  };
}

function convertUtilityTypes(type) {
  var result = _objectSpread({}, type);
  return "$Exact" === type.value.name && (type.typeParams && type.typeParams.params && type.typeParams.params[0] ? result = type.typeParams.params[0] : console.warn("Missing type parameter for $Exact type")), 
  result;
}

function convertObject(path, context) {
  var members = [];
  return path.get("properties").forEach(function(p) {
    var mem = convert(p, context);
    if ("spread" === mem.kind) {
      var memVal = resolveFromGeneric(mem.value);
      if ("initial" === memVal.kind && "object" === memVal.value.kind) members = members.concat(memVal.value.members); else if ("object" === memVal.kind) members = members.concat(memVal.members); else if ("variable" === memVal.kind) {
        var declarations = memVal.declarations;
        if ("object" !== (declarations = declarations[declarations.length - 1].value).kind) throw new Error("Trying to spread a non-object item onto an object");
        members = members.concat(declarations.members);
      } else members = (memVal.kind, members.concat(mem));
    } else "property" === mem.kind && members.push(mem);
  }), {
    kind: "object",
    members: members
  };
}

function extendedTypesMembers(path, context) {
  var members = path.get("extends");
  return members && members.length ? members.reduce(function(acc, current) {
    var converted = convert(current, context);
    return acc.concat(converted.members);
  }, []) : [];
}

function importConverterGeneral(path, context) {
  var name, importKind = path.node.importKind || path.parent.importKind || "value", moduleSpecifier = path.parent.source.value, kind = path.parent.importKind;
  if (name = "ImportDefaultSpecifier" === path.type && "value" === kind ? "default" : path.node.imported ? path.node.imported.name : path.node.local.name, 
  path.hub.file.opts.filename) {
    if ("typeof" === kind) throw new Error({
      path: path,
      error: "import typeof is unsupported"
    });
    var filePath;
    try {
      filePath = babelFileLoader.resolveImportFilePathSync(path.parentPath, context.resolveOptions);
    } catch (e) {
      return {
        kind: "import",
        importKind: importKind,
        name: name,
        moduleSpecifier: moduleSpecifier
      };
    }
    if (!filePath) return {
      kind: "import",
      importKind: importKind,
      name: name,
      moduleSpecifier: moduleSpecifier
    };
    if (".json" === nodePath.extname(filePath)) return {
      kind: "import",
      importKind: importKind,
      name: name,
      moduleSpecifier: moduleSpecifier
    };
    var id, file = babelFileLoader.loadFileSync(filePath, context.parserOpts);
    id = path.node.imported ? path.node.imported.name : path.node.local.name;
    var exported = matchExported(file, name);
    return exported || (exported = recursivelyResolveExportAll(file.path, context, name)) ? convert(exported, _objectSpread({}, context, {
      replacementId: t.identifier(id)
    })) : {
      kind: "import",
      importKind: importKind,
      name: name,
      moduleSpecifier: moduleSpecifier
    };
  }
  return {
    kind: "import",
    importKind: importKind,
    name: name,
    moduleSpecifier: moduleSpecifier
  };
}

function recursivelyResolveExportAll(path, context, name) {
  var source = path.get("body").filter(function(item) {
    return item.isExportAllDeclaration();
  }).map(function(item) {
    return resolveExportAllDeclaration(item, context);
  }).filter(Boolean), matchedDeclartion = source.reduce(function(acc, current) {
    return acc || matchExported(current, name);
  }, null);
  return matchedDeclartion || source.reduce(function(acc, current) {
    return acc || recursivelyResolveExportAll(current.path, context, name);
  }, null);
}

function resolveExportAllDeclaration(path, context) {
  var source = path.get("source"), filePath = babelFileLoader.resolveImportFilePathSync(source.parentPath, context.resolveOptions);
  return babelFileLoader.loadFileSync(filePath, context.parserOpts);
}

function convertMethodCall(path, context) {
  var parameters = path.get("parameters").map(function(p) {
    return convertParameter(p, context);
  });
  return {
    kind: "function",
    returnType: convert(path.get("typeAnnotation"), context),
    parameters: parameters
  };
}

function mapComment(comment) {
  return {
    type: "CommentLine" === comment.type ? "commentLine" : "commentBlock",
    value: babelNormalizeComments.normalizeComment(comment),
    raw: comment.value
  };
}

function attachCommentProperty(source, dest, name) {
  if (source && source[name]) {
    dest[name] || (dest[name] = []);
    var comments = source[name].map(mapComment);
    dest[name] = dest[name].concat(comments);
  }
}

function attachComments(source, dest) {
  attachCommentProperty(source, dest, "leadingComments"), attachCommentProperty(source, dest, "trailingComments"), 
  attachCommentProperty(source, dest, "innerComments");
}

converters.Program = function(path, context) {
  var component, components = exportedComponents(path, "default", context);
  return components[0] && (component = components[0].component), component || path.traverse({
    ClassDeclaration: function(scopedPath) {
      !component && babelReactComponents.isReactComponentClass(scopedPath) && (component = convertReactComponentClass(scopedPath, context));
    }
  }), {
    kind: "program",
    component: component
  };
}, converters.TaggedTemplateExpression = function(path, context) {
  return {
    kind: "templateExpression",
    tag: convert(path.get("tag"), context)
  };
}, converters.TemplateElement = function(path, context) {
  return {
    kind: "templateElement",
    value: path.node.value
  };
}, converters.TemplateLiteral = function(path, context) {
  return {
    kind: "templateLiteral",
    expressions: path.get("expressions").map(function(e) {
      return convert(e, context);
    }),
    quasis: path.get("quasis").map(function(q) {
      return convert(q, context);
    })
  };
}, converters.LogicalExpression = function(path, context) {
  return {
    kind: "logicalExpression",
    operator: path.node.operator,
    left: convert(path.get("left"), context),
    right: convert(path.get("right"), context)
  };
}, converters.RestElement = function(path, context) {
  return {
    kind: "rest",
    argument: convert(path.get("argument"), context)
  };
}, converters.AssignmentPattern = function(path, context) {
  return {
    kind: "assignmentPattern",
    left: convert(path.get("left"), context),
    right: convert(path.get("right"), context)
  };
}, converters.ObjectPattern = function(path, context) {
  var members = [], _iteratorNormalCompletion = !0, _didIteratorError = !1, _iteratorError = void 0;
  try {
    for (var _step, _iterator = path.get("properties")[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = !0) {
      var property = _step.value;
      members.push(convert(property, context));
    }
  } catch (err) {
    _didIteratorError = !0, _iteratorError = err;
  } finally {
    try {
      _iteratorNormalCompletion || null == _iterator.return || _iterator.return();
    } finally {
      if (_didIteratorError) throw _iteratorError;
    }
  }
  return {
    kind: "objectPattern",
    members: members
  };
}, converters.ClassDeclaration = function(path, context) {
  return babelReactComponents.isReactComponentClass(path) ? convertReactComponentClass(path, context) : {
    kind: "class",
    name: convert(path.get("id"), context)
  };
}, converters.SpreadElement = function(path, context) {
  return {
    kind: "spread",
    value: convert(path.get("argument"), context)
  };
}, converters.SpreadProperty = function(path, context) {
  return {
    kind: "spread",
    value: convert(path.get("argument"), context)
  };
}, converters.UnaryExpression = function(path, context) {
  return {
    kind: "unary",
    operator: path.node.operator,
    argument: convert(path.get("argument"), context)
  };
}, converters.JSXAttribute = function(path, context) {
  return {
    kind: "JSXAttribute",
    name: convert(path.get("name"), context),
    value: convert(path.get("value"), context)
  };
}, converters.JSXExpressionContainer = function(path, context) {
  return {
    kind: "JSXExpressionContainer",
    expression: convert(path.get("expression"), context)
  };
}, converters.JSXElement = function(path, context) {
  return {
    kind: "JSXElement",
    value: convert(path.get("openingElement"), context)
  };
}, converters.JSXIdentifier = function(path, context) {
  return {
    kind: "JSXIdentifier",
    value: path.node.name
  };
}, converters.JSXMemberExpression = function(path, context) {
  return {
    kind: "JSXMemberExpression",
    object: convert(path.get("object"), context),
    property: convert(path.get("property"), context)
  };
}, converters.JSXOpeningElement = function(path, context) {
  return {
    kind: "JSXOpeningElement",
    name: convert(path.get("name"), context),
    attributes: path.get("attributes").map(function(item) {
      return convert(item, context);
    })
  };
}, converters.ClassProperty = function(path, context) {
  return {
    kind: "property",
    key: convert(path.get("key"), context),
    value: convert(path.get("value"), context)
  };
}, converters.CallExpression = function(path, context) {
  var _convertCall = convertCall(path, context);
  return {
    kind: "call",
    callee: _convertCall.callee,
    args: _convertCall.args
  };
}, converters.NewExpression = function(path, context) {
  var _convertCall2 = convertCall(path, context);
  return {
    kind: "new",
    callee: _convertCall2.callee,
    args: _convertCall2.args
  };
}, converters.InterfaceDeclaration = function(path, context) {
  return {
    kind: "interfaceDeclaration",
    id: convert(path.get("id"), context)
  };
}, converters.OpaqueType = function(path, context) {
  var supertype, impltype, typeParameters, supertypePath = path.get("supertype"), impltypePath = path.get("impltype"), typeParametersPath = path.get("typeParameters"), id = convert(path.get("id"), context);
  return supertypePath.node && (supertype = convert(supertypePath, context)), impltypePath.node && (impltype = convert(impltypePath, context)), 
  typeParametersPath.node && (typeParameters = convert(typeParametersPath, context)), 
  {
    kind: "opaqueType",
    id: id,
    supertype: supertype,
    impltype: impltype,
    typeParameters: typeParameters
  };
}, converters.TypeofTypeAnnotation = function(path, context) {
  var type = convert(path.get("argument"), _objectSpread({}, context, {
    mode: "value"
  })), ungeneric = resolveFromGeneric(type);
  return {
    kind: "typeof",
    type: type,
    name: ungeneric.name || ungeneric.referenceIdName
  };
}, converters.ObjectProperty = function(path, context) {
  return {
    kind: "property",
    key: convert(path.get("key"), context),
    value: convert(path.get("value"), context)
  };
}, converters.ExistentialTypeParam = function(path, context) {
  return {
    kind: "exists"
  };
}, converters.StringLiteral = function(path, context) {
  return {
    kind: "string",
    value: path.node.value
  };
}, converters.TypeCastExpression = function(path, context) {
  return {
    kind: "typeCastExpression",
    expression: convert(path.get("expression"), context)
  };
}, converters.NumericLiteral = function(path, context) {
  return {
    kind: "number",
    value: path.node.value
  };
}, converters.NullLiteral = function(path, context) {
  return {
    kind: "null"
  };
}, converters.BooleanLiteral = function(path, context) {
  return {
    kind: "boolean",
    value: path.node.value
  };
}, converters.ArrayExpression = function(path, context) {
  return {
    kind: "array",
    elements: path.get("elements").map(function(e) {
      return convert(e, context);
    })
  };
}, converters.BinaryExpression = function(path, context) {
  return {
    kind: "binary",
    operator: path.node.operator,
    left: convert(path.get("left"), context),
    right: convert(path.get("right"), context)
  };
}, converters.MemberExpression = function(path, context) {
  return {
    kind: "memberExpression",
    object: convert(path.get("object"), context),
    property: convert(path.get("property"), context)
  };
}, converters.FunctionDeclaration = function(path, context) {
  return convertFunction(path, context);
}, converters.ArrowFunctionExpression = function(path, context) {
  return convertFunction(path, context);
}, converters.FunctionExpression = function(path, context) {
  return convertFunction(path, context);
}, converters.TypeAnnotation = function(path, context) {
  return convert(path.get("typeAnnotation"), context);
}, converters.ExistsTypeAnnotation = function(path, context) {
  return {
    kind: "exists"
  };
}, converters.ObjectTypeAnnotation = function(path, context) {
  return convertObject(path, context);
}, converters.ObjectTypeProperty = function(path, context) {
  var result = {
    kind: "property"
  };
  return result.key = convert(path.get("key"), context), result.value = convert(path.get("value"), context), 
  result.optional = path.node.optional, result;
}, converters.UnionTypeAnnotation = function(path, context) {
  return {
    kind: "union",
    types: path.get("types").map(function(p) {
      return convert(p, context);
    })
  };
}, converters.TypeParameterInstantiation = function(path, context) {
  return {
    kind: "typeParams",
    params: path.get("params").map(function(p) {
      return convert(p, context);
    })
  };
}, converters.TypeParameterDeclaration = function(path, context) {
  return {
    kind: "typeParamsDeclaration",
    params: path.get("params").map(function(p) {
      return convert(p, context);
    })
  };
}, converters.TypeParameter = function(path, context) {
  return {
    kind: "typeParam",
    name: path.node.name
  };
}, converters.GenericTypeAnnotation = function(path, context) {
  var result = {
    kind: "generic"
  };
  return result.value = convert(path.get("id"), context), path.node.typeParameters && (result.typeParams = convert(path.get("typeParameters"), context)), 
  "id" === result.value.kind && (result = convertUtilityTypes(result)), result;
}, converters.ObjectMethod = function(path, context) {
  var parameters = path.get("params").map(function(p) {
    return convertParameter(p, context);
  }), returnType = null;
  return path.node.returnType && (returnType = convert(path.get("returnType"), context)), 
  {
    kind: "function",
    id: null,
    async: path.node.async,
    generator: path.node.generator,
    parameters: parameters,
    returnType: returnType
  };
}, converters.ObjectExpression = function(path, context) {
  return convertObject(path, context);
}, converters.VariableDeclaration = function(path, context) {
  var res = {
    kind: "variable"
  };
  return res.declarations = path.get("declarations").map(function(p) {
    return convert(p, context);
  }), res;
}, converters.VariableDeclarator = function(path, context) {
  return {
    kind: "initial",
    id: convert(path.get("id"), context),
    value: convert(path.get("init"), context)
  };
}, converters.Identifier = function(path, context) {
  var kind = babelIdentifiers.getIdentifierKind(path), name = path.node.name;
  if ("value" === context.mode) {
    if ("reference" === kind) {
      var binding = path.scope.getBinding(name);
      if (binding) {
        var bindingPath = binding.path, foundPath = null;
        if (bindingPath.isVariableDeclaration() ? foundPath = bindingPath.get("declarators").find(function(p) {
          return p.node.name === name;
        }) : bindingPath.isVariableDeclarator() ? foundPath = bindingPath.get("init") : bindingPath.isImportDefaultSpecifier() || bindingPath.isImportNamespaceSpecifier() ? foundPath = bindingPath : bindingPath.isImportSpecifier() ? foundPath = bindingPath : bindingPath.isDeclaration() && (foundPath = bindingPath.get("id")), 
        null == foundPath) throw new Error("Unable to resolve binding path for: ".concat(bindingPath.type));
        var convertedValue = convert(foundPath, context);
        return _objectSpread({}, convertedValue, {
          referenceIdName: path.node.name
        });
      }
      var type = null;
      return path.node.typeAnnotation && (type = convert(path.get("typeAnnotation"), _objectSpread({}, context, {
        mode: "type"
      }))), {
        kind: "id",
        name: name,
        type: type
      };
    }
    if ("static" === kind || "binding" === kind) {
      var _type = null;
      return path.node.typeAnnotation && (_type = convert(path.get("typeAnnotation"), _objectSpread({}, context, {
        mode: "type"
      }))), {
        kind: "id",
        name: name,
        type: _type
      };
    }
    throw new Error("Unable to resolve path for: ".concat(kind));
  }
  if ("type" === context.mode) if ("reference" === kind) {
    var _bindingPath;
    if (babelFlowIdentifiers.isFlowIdentifier(path)) {
      var flowBinding = babelTypeScopes.getTypeBinding(path, name);
      if (!flowBinding) throw new Error();
      _bindingPath = flowBinding.path.parentPath;
    } else if (isTsIdentifier(path)) {
      var _foundPath = path.scope.getBinding(name);
      if (_foundPath && (_foundPath.path.isImportDefaultSpecifier() || _foundPath.path.isImportNamespaceSpecifier() || _foundPath.path.isImportSpecifier())) return convert(_foundPath.path, context);
      var tsBinding = babelTypeScopes.getTypeBinding(path, name);
      if (!tsBinding) return {
        kind: "id",
        name: name
      };
      _bindingPath = tsBinding.path.parentPath;
    } else _bindingPath = path.scope.getBinding(name);
    if (!_bindingPath) return {
      kind: "id",
      name: name
    };
    if ("module" === _bindingPath.kind && (_bindingPath = _bindingPath.path), path.isDescendant(_bindingPath) && _bindingPath.get("id").node.name === name) return {
      kind: "id",
      name: name
    };
    if ("unknown" === _bindingPath.kind) return {
      kind: "id",
      name: name
    };
    if ("module" !== _bindingPath.kind) {
      var _convertedValue = convert(_bindingPath, context);
      return _objectSpread({}, _convertedValue, {
        referenceIdName: path.node.name
      });
    }
  } else if ("static" === kind || "binding" === kind) return {
    kind: "id",
    name: name
  };
  throw new Error("Could not parse Identifier ".concat(name, " in mode ").concat(context.mode));
}, converters.TypeAlias = function(path, context) {
  return convert(path.get("right"), context);
}, converters.IntersectionTypeAnnotation = function(path, context) {
  return {
    kind: "intersection",
    types: path.get("types").map(function(p) {
      return convert(p, context);
    })
  };
}, converters.QualifiedTypeIdentifier = function(path, context) {
  return convert(path.get("id"), context);
}, converters.VoidTypeAnnotation = function(path) {
  return {
    kind: "void"
  };
}, converters.BooleanTypeAnnotation = function(path) {
  return {
    kind: "boolean"
  };
}, converters.BooleanLiteralTypeAnnotation = function(path) {
  return {
    kind: "boolean",
    value: path.node.value
  };
}, converters.NullLiteralTypeAnnotation = function(path) {
  return {
    kind: "null"
  };
}, converters.StringLiteralTypeAnnotation = function(path) {
  return {
    kind: "string",
    value: path.node.value
  };
}, converters.NumberLiteralTypeAnnotation = function(path) {
  return {
    kind: "number",
    value: path.node.value
  };
}, converters.MixedTypeAnnotation = function(path) {
  return {
    kind: "mixed"
  };
}, converters.AnyTypeAnnotation = function(path) {
  return {
    kind: "any"
  };
}, converters.NumberTypeAnnotation = function(path) {
  return {
    kind: "number"
  };
}, converters.FunctionTypeParam = function(path, context) {
  return convert(path.get("typeAnnotation"), context);
}, converters.FunctionTypeAnnotation = function(path, context) {
  return {
    parameters: path.get("params").map(function(p) {
      return convertParameter(p, context);
    }),
    returnType: convert(path.get("returnType"), context),
    kind: "function"
  };
}, converters.StringTypeAnnotation = function(path) {
  return {
    kind: "string"
  };
}, converters.NullableTypeAnnotation = function(path, context) {
  return {
    kind: "nullable",
    arguments: convert(path.get("typeAnnotation"), context)
  };
}, converters.TSIndexedAccessType = function(path, context) {
  var type = convert(path.get("objectType"), context), indexKey = path.get("indexType").node.literal.value;
  if ("generic" === type.kind) {
    if (type.value.members) {
      var member = type.value.members.find(function(scopedMember) {
        return scopedMember.key.name === indexKey;
      });
      if (member) return member.value;
    }
    var name = type.value.name || type.value.referenceIdName;
    return {
      kind: "generic",
      value: {
        kind: type.value.kind,
        name: "".concat(name.name || name, "['").concat(indexKey, "']")
      }
    };
  }
  throw new Error("Unsupported TSIndexedAccessType kind: ".concat(type.kind));
}, converters.TSStringKeyword = function(path) {
  return {
    kind: "string"
  };
}, converters.TSNumberKeyword = function(path) {
  return {
    kind: "number"
  };
}, converters.TSBooleanKeyword = function(path) {
  return {
    kind: "boolean"
  };
}, converters.TSVoidKeyword = function(path) {
  return {
    kind: "void"
  };
}, converters.TSUndefinedKeyword = function(path, context) {
  return {
    kind: "void"
  };
}, converters.TSTypeLiteral = function(path, context) {
  return {
    kind: "object",
    members: path.get("members").map(function(memberPath) {
      return convert(memberPath, context);
    })
  };
}, converters.TSPropertySignature = function(path, context) {
  return {
    kind: "property",
    optional: !!path.node.optional,
    key: convert(path.get("key"), context),
    value: convert(path.get("typeAnnotation"), context)
  };
}, converters.TSTypeAliasDeclaration = function(path, context) {
  return convert(path.get("typeAnnotation"), context);
}, converters.TSLiteralType = function(path) {
  return {
    kind: "string",
    value: path.node.literal.value
  };
}, converters.TSTypeReference = function(path, context) {
  var typeParameters = path.get("typeParameters");
  return typeParameters.node ? {
    kind: "generic",
    typeParams: convert(typeParameters, context),
    key: convert(path.get("key"), context),
    value: convert(path.get("typeName"), context)
  } : {
    kind: "generic",
    value: convert(path.get("typeName"), context)
  };
}, converters.TSUnionType = function(path, context) {
  return {
    kind: "union",
    types: path.get("types").map(function(p) {
      return convert(p, context);
    })
  };
}, converters.TSAnyKeyword = function(path) {
  return {
    kind: "any"
  };
}, converters.TSTupleType = function(path, context) {
  return {
    kind: "tuple",
    types: path.get("elementTypes").map(function(p) {
      return convert(p, context);
    })
  };
}, converters.TSFunctionType = function(path, context) {
  var parameters = path.get("parameters").map(function(p) {
    return convertParameter(p, context);
  });
  return {
    kind: "generic",
    value: {
      kind: "function",
      returnType: convert(path.get("typeAnnotation"), context),
      parameters: parameters
    }
  };
}, converters.TSMethodSignature = function(path, context) {
  return {
    kind: "property",
    optional: !!path.node.optional,
    key: convert(path.get("key"), context),
    value: convertMethodCall(path, context)
  };
}, converters.TSCallSignatureDeclaration = function(path, context) {
  return {
    kind: "property",
    key: {
      kind: "string"
    },
    optional: !1,
    value: convertMethodCall(path, context)
  };
}, converters.TSInterfaceDeclaration = function(path, context) {
  var extendedTypes = extendedTypesMembers(path, context);
  return {
    kind: "object",
    members: (convert(path.get("body"), context) || {
      members: []
    }).members.concat(extendedTypes)
  };
}, converters.TSExpressionWithTypeArguments = function(path, context) {
  return convert(path.get("expression"), context);
}, converters.TSInterfaceBody = function(path, context) {
  return {
    kind: "object",
    members: path.get("body").map(function(prop) {
      return convert(prop, context);
    })
  };
}, converters.TSTypeAnnotation = function(path, context) {
  return convert(path.get("typeAnnotation"), context);
}, converters.TSQualifiedName = function(path, context) {
  var left = convert(path.get("left"), context), right = convert(path.get("right"), context);
  return {
    kind: "id",
    name: "".concat(left.name || left.referenceIdName, ".").concat(right.name)
  };
}, converters.TSEnumDeclaration = function(path, context) {
  var name = path.get("id").node.name;
  return {
    kind: "union",
    types: path.get("members").map(function(p) {
      var member = convert(p, context);
      return {
        kind: member.kind,
        name: "".concat(name, ".").concat(member.name)
      };
    })
  };
}, converters.TSEnumMember = function(path, context) {
  return convert(path.get("id"), context);
}, converters.TSArray = function(path, context) {
  return {
    kind: "any"
  };
}, converters.TSArrayType = function(path, context) {
  return {
    kind: "arrayType",
    type: convert(path.get("elementType"), context)
  };
}, converters.TSTypeParameterInstantiation = function(path, context) {
  return {
    kind: "typeParams",
    params: path.get("params").map(function(param) {
      return convert(param, context);
    })
  };
}, converters.ImportNamespaceSpecifier = function(path, context) {
  return {
    kind: "any"
  };
}, converters.undefined = function(path, context) {
  return {
    kind: "any"
  };
}, converters.ObjectTypeSpreadProperty = function(path, context) {
  return {
    kind: "spread",
    value: convert(path.get("argument"), context)
  };
}, converters.ArrayTypeAnnotation = function(path, context) {
  return {
    kind: "arrayType",
    type: convert(path.get("elementType"), context)
  };
}, converters.TSIntersectionType = function(path, context) {
  return {
    kind: "intersection",
    types: path.get("types").map(function(type) {
      return convert(type, context);
    })
  };
}, converters.TSIndexSignature = function(path, context) {
  var id = path.get("parameters")[0];
  return {
    kind: "property",
    key: {
      kind: "id",
      name: "[".concat(convert(id, context).name, ": ").concat(convert(id.get("typeAnnotation"), context).kind, "]")
    },
    value: convert(path.get("typeAnnotation"), context)
  };
}, converters.TSParenthesizedType = function(path, context) {
  return convert(path.get("typeAnnotation"), context);
}, converters.TSObjectKeyword = function(path, context) {
  return {
    kind: "object",
    members: []
  };
}, converters.TSNullKeyword = function(path, context) {
  return {
    kind: "null"
  };
}, converters.TSThisType = function(path, context) {
  return {
    kind: "custom",
    value: "this"
  };
}, converters.TSAsExpression = function(path, context) {
  return convert(path.get("expression"), context);
}, converters.ImportDefaultSpecifier = function(path, context) {
  return importConverterGeneral(path, context);
}, converters.ImportDeclaration = function(path, context) {
  var importKind = path.node.importKind || "value", moduleSpecifier = path.get("source").node.value;
  if (!context.replacementId) return {
    kind: "import",
    importKind: importKind,
    name: "default",
    moduleSpecifier: moduleSpecifier
  };
  var filePath = babelFileLoader.resolveImportFilePathSync(path, context.resolveOptions), exported = matchExported(babelFileLoader.loadFileSync(filePath, context.parserOpts), context.replacementId.name);
  return exported ? convert(exported, context) : {
    kind: "import",
    importKind: importKind,
    name: "default",
    moduleSpecifier: moduleSpecifier
  };
}, converters.ExportSpecifier = function(path, context) {
  return {
    kind: "exportSpecifier",
    local: convert(path.get("local"), context),
    exported: convert(path.get("exported"), context)
  };
}, converters.ExportNamedDeclaration = function(path, context) {
  var specifiers = path.get("specifiers");
  if (!path.get("source").node) return {
    kind: "export",
    exports: specifiers.map(function(s) {
      return convert(s, context);
    })
  };
  var source = path.get("source");
  if (1 !== specifiers.length) return {
    kind: "export",
    exports: specifiers.map(function(s) {
      return convert(s, context);
    }),
    source: convert(source, context)
  };
  var name = convert(specifiers[0], context).local.name;
  try {
    var filePath = babelFileLoader.resolveImportFilePathSync(source.parentPath, context.resolveOptions), actualPath = resolve.sync(nodePath.join(nodePath.dirname(filePath), source.node.value), context.resolveOptions), resolvedValue = matchExported(babelFileLoader.loadFileSync(actualPath, context.parserOpts), name);
    return resolvedValue ? convert(resolvedValue, context) : {
      kind: "export",
      exports: specifiers.map(function(s) {
        return convert(s, context);
      }),
      source: convert(source, context)
    };
  } catch (e) {
    return {
      kind: "export",
      exports: specifiers.map(function(s) {
        return convert(s, context);
      }),
      source: convert(source, context)
    };
  }
}, converters.ImportSpecifier = function(path, context) {
  return importConverterGeneral(path, context);
}, converters.TSConditionalType = function() {
  return {
    kind: "any"
  };
};

var getCircularReplacer = function() {
  var seen = new WeakSet();
  return function(key, value) {
    if ("object" === _typeof(value) && null !== value) {
      if (seen.has(value)) return;
      seen.add(value);
    }
    return value;
  };
};

function convert(path, context) {
  if ("function" != typeof path.get) {
    var stringedPath = JSON.stringify(path, getCircularReplacer(), 2);
    throw new Error("Did not pass a NodePath to convert() ".concat(stringedPath));
  }
  var converter = converters[path.type];
  if (!converter) throw new Error("Missing converter for: ".concat(path.type));
  var result = converter(path, context);
  return attachComments(path.node, result), result;
}

function getContext(typeSystem, filename, resolveOptions) {
  var plugins = [ "jsx", [ "decorators", {
    decoratorsBeforeExport: !0
  } ] ];
  if (resolveOptions || (resolveOptions = {}), resolveOptions.extensions || (resolveOptions.extensions = [ ".js", ".json" ]), 
  "flow" === typeSystem) plugins.push([ "flow", {
    all: !0
  } ]); else {
    if ("typescript" !== typeSystem) throw new Error('typeSystem must be either "flow" or "typescript"');
    plugins.push("typescript"), resolveOptions.extensions.push(".tsx"), resolveOptions.extensions.push(".ts");
  }
  return {
    resolveOptions: resolveOptions,
    parserOpts: createBabylonOptions({
      stage: 2,
      plugins: plugins
    })
  };
}

function extractReactTypes(code, typeSystem, filename, inputResolveOptions) {
  var _getContext = getContext(typeSystem, filename, inputResolveOptions), resolveOptions = _getContext.resolveOptions, parserOpts = _getContext.parserOpts;
  return convert(createBabelFile(code, {
    parserOpts: parserOpts,
    filename: filename
  }).path, {
    resolveOptions: resolveOptions,
    parserOpts: parserOpts
  });
}

function findExports(path, exportsToFind) {
  var moduleExports = path.get("body").filter(function(bodyPath) {
    return "default" === exportsToFind ? bodyPath.isExportDefaultDeclaration() : bodyPath.isExportNamedDeclaration() && null === bodyPath.node.source && ("value" === bodyPath.node.exportKind || void 0 === bodyPath.node.exportKind) || bodyPath.isExportDefaultDeclaration();
  }), formattedExports = [];
  return moduleExports.forEach(function(exportPath) {
    if (exportPath.isExportDefaultDeclaration()) {
      var declaration = exportPath.get("declaration");
      if (declaration.isIdentifier()) {
        var binding = path.scope.bindings[declaration.node.name].path;
        binding.isVariableDeclarator() && (binding = binding.get("init")), formattedExports.push({
          name: declaration.node.name,
          path: binding
        });
      } else {
        var name = null;
        (declaration.isClassDeclaration() || declaration.isFunctionDeclaration()) && null !== declaration.node.id && (name = declaration.node.id.name), 
        formattedExports.push({
          name: name,
          path: declaration
        });
      }
    } else {
      var _declaration = exportPath.get("declaration"), specifiers = exportPath.get("specifiers");
      if (0 === specifiers.length) {
        if (_declaration.isFunctionDeclaration() || _declaration.isClassDeclaration()) {
          var identifier = _declaration.node.id;
          formattedExports.push({
            name: null === identifier ? null : identifier.name,
            path: _declaration
          });
        }
        _declaration.isVariableDeclaration() && _declaration.get("declarations").forEach(function(declarator) {
          formattedExports.push({
            name: declarator.node.id.name,
            path: declarator.get("init")
          });
        });
      } else specifiers.forEach(function(specifier) {
        var name = specifier.node.local.name, binding = path.scope.bindings[name].path;
        binding.isVariableDeclarator() && (binding = binding.get("init")), formattedExports.push({
          name: name,
          path: binding
        });
      });
    }
  }), formattedExports;
}

function exportedComponents(programPath, componentsToFind, context) {
  var components = [];
  return findExports(programPath, componentsToFind).forEach(function(_ref) {
    var path = _ref.path, name = _ref.name;
    if (path.isFunctionExpression() || path.isArrowFunctionExpression() || path.isFunctionDeclaration()) {
      var component = convertReactComponentFunction(path, context);
      components.push({
        name: name,
        path: path,
        component: component
      });
    } else if (path.isClass()) {
      var _component = convertReactComponentClass(path, context);
      components.push({
        name: name,
        path: path,
        component: _component
      });
    } else {
      var isMemo = isSpecialReactComponentType(path, "memo");
      if (isMemo || isSpecialReactComponentType(path, "forwardRef")) {
        var firstArg = path.get("arguments")[0];
        if (firstArg) {
          if (firstArg.isFunctionExpression() || firstArg.isArrowFunctionExpression()) {
            var _component2 = convertReactComponentFunction(firstArg, context);
            return void components.push({
              name: name,
              path: path,
              component: _component2
            });
          }
          if (isMemo && isSpecialReactComponentType(firstArg, "forwardRef")) {
            var innerFirstArg = firstArg.get("arguments")[0];
            if (innerFirstArg.isFunctionExpression() || innerFirstArg.isArrowFunctionExpression()) {
              var _component3 = convertReactComponentFunction(innerFirstArg, context);
              components.push({
                name: name,
                path: path,
                component: _component3
              });
            }
          }
        }
      }
    }
  }), components;
}

var findExportedComponents = function(programPath, typeSystem, filename, resolveOptions) {
  return exportedComponents(programPath, "all", getContext(typeSystem, filename, resolveOptions));
};

exports.extractReactTypes = extractReactTypes, exports.findExportedComponents = findExportedComponents;
